CodeForces - 731C Socks

54 篇文章 0 订阅

Arseniy is already grown-up and independent. His mother decided to leave him alone for m days and left on a vacation. She have prepared a lot of food, left some money and washed all Arseniy’s clothes.

Ten minutes before her leave she realized that it would be also useful to prepare instruction of which particular clothes to wear on each of the days she will be absent. Arseniy’s family is a bit weird so all the clothes is enumerated. For example, each of Arseniy’s n socks is assigned a unique integer from 1 to n. Thus, the only thing his mother had to do was to write down two integers li and ri for each of the days — the indices of socks to wear on the day i (obviously, li stands for the left foot and ri for the right). Each sock is painted in one of k colors.

When mother already left Arseniy noticed that according to instruction he would wear the socks of different colors on some days. Of course, that is a terrible mistake cause by a rush. Arseniy is a smart boy, and, by some magical coincidence, he posses k jars with the paint — one for each of k colors.

Arseniy wants to repaint some of the socks in such a way, that for each of m days he can follow the mother’s instructions and wear the socks of the same color. As he is going to be very busy these days he will have no time to change the colors of any socks so he has to finalize the colors now.

The new computer game Bota-3 was just realised and Arseniy can’t wait to play it. What is the minimum number of socks that need their color to be changed in order to make it possible to follow mother’s instructions and wear the socks of the same color during each of m days.

Input
The first line of input contains three integers n, m and k (2 ≤ n ≤ 200 000, 0 ≤ m ≤ 200 000, 1 ≤ k ≤ 200 000) — the number of socks, the number of days and the number of available colors respectively.

The second line contain n integers c1, c2, …, cn (1 ≤ ci ≤ k) — current colors of Arseniy’s socks.

Each of the following m lines contains two integers li and ri (1 ≤ li, ri ≤ n, li ≠ ri) — indices of socks which Arseniy should wear during the i-th day.

Output
Print one integer — the minimum number of socks that should have their colors changed in order to be able to obey the instructions and not make people laugh from watching the socks of different colors.

Example
Input
3 2 3
1 2 3
1 2
2 3
Output
2
Input
3 2 2
1 1 2
1 2
2 1
Output
0
题意:n只袜子,m天穿,k种颜色。m天每天给你要穿的袜子的下标。问要在每天穿的袜子颜色相同的情况下,你要修改的袜子的颜色的最小数量。
我们转化一下题意,把m天看作m条边,这样满足条件的情况其实就是相邻的点颜色要相同,这样我们可以dfs连通块,统计每个联通块中的颜色数量,然后连通块中的点数减去颜色的最大值,就是要修改的颜色数量,所有连通块这样加起来就是答案。
一开始用数组暴力清0很明显的T了。 O(n2) 极限复杂度。
我们可以发现每次数组清0做了很多的无用功,因为很多搜索的时候根本就没有搜索到。于是我们用map来记录个数,每次搜索到一个点的时候更新最大值。这样每个(下标)点最多就是map统计一次,复杂度变成 O(nlogn)

#include <bits/stdc++.h>

using namespace std;
const int MAXN = 2e5+7;
int n,m,k;
int num[MAXN];
bool vis[MAXN];
vector<int>head[MAXN];
map<int,int>color;
int MAX,sum;
void dfs(int u)
{
    sum++;
    vis[u] = 1;
    int &t = color[num[u]];
    t++;
    MAX = t>MAX?t:MAX;
    for(int i = 0,l = head[u].size(); i < l; ++i)
    {
        int v = head[u][i];
        if(!vis[v])dfs(v);
    }
}


int main()
{
    scanf("%d%d%d",&n,&m,&k);
    for(int i = 1; i <= n; ++i)scanf("%d",&num[i]);
    int u,v;
    while(m--)
    {
        scanf("%d%d",&u,&v);
        head[u].push_back(v);
        head[v].push_back(u);
    }
    int ans = 0;
    for(int i = 1; i <= n; ++i)
    {
        if(!vis[i])
        {
            sum = 0;
            MAX = 0;
            color.clear();
            dfs(i);
            ans += sum - MAX;
        }
    }
    printf("%d\n",ans);
    return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值